;=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=;
;=                                                                         =;
;= V2 OS System Boot-Code (C)1999 V2_Lab, Rotterdam.                       =;
;=                                                                         =;
;=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=_=;
.MODEL TINY
.CODE
.386
       ORG 100h

START:
   JMP BEGIN            ; 3-BYTE-INSTRUCTION

     FILLBYTES          DB 5 DUP(255)         ; 3
     SIGNATURE          DB '+V2_FS+', 0       ; 8
     FS_VERSION         DB '001.001', 0       ; 16
     MAXOBJECTS         DD 128                ; 24
     CUROBJECTS         DD 0                  ; 28
     MAXSECTORS         DD 011223344H         ; 32
     FIRST_AVAILABLE    DD 16                 ; 36
     SECTORS4SYSTEM16   DB 0                  ; 40
     SECTORS4SYSTEM32   DB 0                  ; 41
     FIRSTDATASECTOR    DD 0                  ; 42
     BOOTCODE:                                ; 46

     V2OS            DB 13,10,'V2-OS',13,10, 0
     LOADFAIL        DB 13,10,'Failed.SysLock', 0
     LOADOK          DB 'Ok',13, 10, 0
     HEXTAB          DB '0123456789ABCDEF'

     SECTORSTOLOAD   DB 15
     READ_SECTOR     DB 0
     READ_HEAD       DB 0
     READ_CYLINDER   DB 0
     BS_SECTOR       DB 0
     BS_HEAD         DB 0
     BS_CYLINDER     DB 0
     BOOTDISK        DB 0
;----------------------------------------------------------------------------
;DISPWORD:
;      PUSH CX
;      PUSH AX
;      PUSH ES
;      PUSH BX
;          SHL DI, 1
;          MOV BX, 0B800H
;          MOV ES, BX
;          ADD DI, 6
;          MOV CX, 4
;DISPWORDLOOP:
;          MOV BX, AX
;          AND BX, 00001111B
;          MOV BL, DS:[OFFSET HEXTAB+BX]
;          MOV ES:[DI], BL
;          MOV BL, 1FH
;          MOV ES:[DI+1], BL
;          SHR AX, 4
;          SUB DI, 2
;         LOOP DISPWORDLOOP
;      POP BX
;      POP ES
;      POP AX
;      POP CX
;     RET

;----------------------------------------------------------------------------
RETRYCOUNT DB 0
READSECTORS:
       MOV RETRYCOUNT, 0

       READLOOP:
        PUSH ECX
        RETRYREAD:
          MOV AH, 2       ; READING SECTOR
          MOV AL, 1
          MOV DL, BOOTDISK           ; DRIVE NR
          MOV DH, READ_HEAD
          MOV CH, READ_CYLINDER
          MOV CL, READ_SECTOR
          INT 13H
       JNC OKREAD1
           MOV AL, RETRYCOUNT
           INC AL
           MOV RETRYCOUNT, AL
           CMP AL, 100
         JBE RETRYREAD
         
         MOV DL, (0 SHL 4) + 07H
         MOV SI, (80*2) * 24
         MOV DI, OFFSET LOADFAIL
         CALL WRITEMSG
         JMP $
OKREAD1:
         PUSHA
           MOV AH, 0EH
           MOV AL, '.'
           MOV BX, 0
           INT 10H
         POPA
         MOV CH, READ_CYLINDER
         MOV CL, READ_SECTOR
         MOV DH, READ_HEAD
         INC CL
         CMP CL, 12h
         JB SECTORSTILLOK
           MOV CL, 1
           INC DH
           CMP DH, 1
           JBE HEADSTILLOK
            MOV DH, 0
            INC CH
         HEADSTILLOK:
        SECTORSTILLOK:
         MOV READ_HEAD, DH
         MOV READ_CYLINDER, CH
         MOV READ_SECTOR, CL
       POP ECX
       ADD BX, 512
       LOOP READLOOP
   RET
;----------------------------------------------------------------------------
WRITEMSG:
  PUSHA
   MOV AH, 03H
   MOV BH, 0
   INT 10H      ; READ CURSORPOS  IN (Y=DH, X=DL)

      NEXTLETTER2:
         MOV AL, DS:[DI]
         CMP AL, 0
         JE OUTWRITELOOP2
          MOV AH, 0EH
          MOV BH, 0
          MOV BL, 5H
          INT 10H
          INC DI
          JMP NEXTLETTER2
       OUTWRITELOOP2:

  POPA
  RET
;----------------------------------------------------------------------------

BEGIN:
       CLI

         MOV AX, CS
         MOV SS, AX
         MOV SP, 16000
         MOV DS, AX
         CMP AX, 0
         JA NODSADJUST
           MOV AX, 7B0H
           MOV DS, AX
NODSADJUST:
       MOV BOOTDISK, DL
   ;    MOV AX, DX
   ;    MOV DI, 8
   ;    CALL DISPWORD

       MOV AH, 0
       INT 13H
       MOV AH, 0
       INT 13H
       MOV DL, (1 SHL 4) + 0FH
       MOV SI, 0
       MOV DI, OFFSET V2OS
       CALL WRITEMSG

       ; PUT THE SYSTEM CODE AT SYSTEM16SEGMENT:0100H

       MOV AL, 1
       MOV READ_SECTOR, AL
       XOR AL, AL
       MOV READ_HEAD, AL
       MOV READ_CYLINDER, AL

       MOV BX, 2050H
       MOV ES, BX      ; SEG BUFFER
       XOR BX, BX      ; OFS BUFFER

       MOV ECX, 1
       CALL READSECTORS               ; READ THE MBR
       MOV BX, 1BEH
       MOV ECX, 4
       FINDPART:
         MOV AL, ES:[BX]
         CMP AL, 80H
         JNE NOTTHISPARTITION
         MOV AL, ES:[BX+4]
         CMP AL, 06H
         JE FOUNDACTIVEPARTITION
         NOTTHISPARTITION:
         ADD BX, 10H
       LOOP FINDPART

         ; NOT FOUND, MUST BE A FLOPPY....
         MOV AL, 1
         MOV READ_SECTOR, AL
         MOV AL, 0
         MOV READ_HEAD, AL
         MOV READ_CYLINDER, AL
         JMP LOADSYSTEM16
FOUNDACTIVEPARTITION:

         MOV AL, ES:[BX+2]
         MOV READ_SECTOR, AL

         MOV AL, ES:[BX+1]
         MOV READ_HEAD, AL
         MOV AL, ES:[BX+3]
         MOV READ_CYLINDER, AL

       LOADSYSTEM16:
       MOV AL, READ_SECTOR
       MOV BS_SECTOR, AL
       INC AL
       MOV READ_SECTOR, AL

       MOV AL, READ_HEAD
       MOV BS_HEAD, AL
       MOV AL, READ_CYLINDER
       MOV READ_CYLINDER, AL

      ; MOV CL, SECTORSTOLOAD
      ; MOVZX ECX, CL
       MOV BX, SYSTEM16SEGMENT
       MOV ES, BX      ; SEG BUFFER
       MOV BX, 100H    ; OFS BUFFER

       MOV ECX, 18
       CALL READSECTORS

       MOV DL,  07H
       MOV SI, (80*2) * 24
       MOV DI, OFFSET LOADOK
       CALL WRITEMSG
       MOV DL, BOOTDISK
       MOV DH, BS_HEAD
       MOV CL, BS_CYLINDER
       MOV CH, BS_SECTOR

       MOV AX, 800H
       MOV ES, AX
       ; QUICK HACK FOR A -FAR- JMP INSTRUCTION
       DB 0EAH
       DW 100H
       SYSTEM16SEGMENT DW 50H
       JMP $
END     start
