char CreateFile(int size)
{
	char result;

	size = (size/512) + 1; //Note that this is not correct, if size=512 - to be fixed!
	asm("
		mov $11, %%al
		mov %1, %%edi
		mov %2, %%ecx
		int $0x20
		mov %%al, %0
		"
		: "=m" (result)
		: "m" (&file_name), "m" (size)
		: "eax", "ecx", "edi"
	);
	return result;
}

void SaveSectors(int StartSect, int SectorAnz)
{
	int BufferSectors = DB_size/512;
	int SectCount;
	int SToGo = SectorAnz;
	int BufPos = TB_ptr;

	if (SToGo==0) return;

	for(;;)
	{
		// Alwayse save maximum of sectors possible at one time
	if( SToGo<BufferSectors ) SectCount=SToGo;
			else SectCount=BufferSectors;

	asm("
		mov %3, %%edi;	// Offset of DiskBuffer
		mov %2, %%esi;	// Offset of out own buffer
		mov %5, %%ecx;	// Size to be moved = sectors * sectorsize
		cld
		push %%ds
		push %%es
		 push %%gs
		 pop %%es
		 push %%gs
		 pop %%ds
		  rep movsb;	//copy DiskBuffer into our own buffer
		pop %%es
		pop %%ds

		mov $07, %%al;	// Select LoadSector function
		mov %0, %%dl;	// Disk
		mov %1, %%ebx;	// First Sector
		mov %4, %%ecx;	// Number of Sectors
		int $0x20;	// do it...
		"
		:
		: "m" (file_disk), "m" (StartSect), "m" (BufPos), "m" (DB_offs), "m" (SectCount), "m" (SectCount*512)
		: "eax", "ebx", "ecx", "edx", "esi", "edi"
	);
	StartSect+=SectCount;
	BufPos+=SectCount*512;
	SToGo-=SectCount;
	if( SToGo<=0 ) break; //finished!
	}
}

void LoadSectors(int StartSect, int SectorAnz)
{
	int BufferSectors = DB_size/512;
	int SectCount;
	int SToGo = SectorAnz;
	int BufPos = TB_ptr;

	if (SToGo==0) return;

	for(;;)
	{
		// Alwayse load maximum of sectors possible at one time
	if( SToGo<BufferSectors ) SectCount=SToGo;
			else SectCount=BufferSectors;

	asm("
		mov $06, %%al;	// Select LoadSector function
		mov %0, %%dl;	// Disk
		mov %1, %%ebx;	// First Sector
		mov %4, %%ecx;	// Number of Sectors
		int $0x20;	// do it...

		mov %3, %%esi;	// Offset of DiskBuffer
		mov %2, %%edi;	// Offset of out own buffer	
		mov %5, %%ecx;	// Size to be moved = sectors * sectorsize
		cld
		push %%ds
		push %%es
		 push %%gs
		 pop %%es
		 push %%gs
		 pop %%ds
		  rep movsb;	//copy DiskBuffer into our own buffer
		pop %%es
		pop %%ds
		"
		:
		: "m" (file_disk), "m" (StartSect), "m" (BufPos), "m" (DB_offs), "m" (SectCount), "m" (SectCount*512)
		: "eax", "ebx", "ecx", "edx", "esi", "edi"
	);
	StartSect+=SectCount;
	BufPos+=SectCount*512;
	SToGo-=SectCount;
	if( SToGo<=0 ) break; //finished!
	}

	SetChar(file_rawlength, 0); //To be sure int ends somewhere...

/*	asm(" mov $28, %%al; int $0x20;" : : : "eax" );
	getkey();
*/
}

void GetBufferInfo()
{
	short temp;
	asm("
		mov %%gs:0x600+84, %%eax;
		mov %%eax, %0;
		mov %%gs:0x600+82, %%ax;
		mov %%ax, %1
		"
		: "=m" (DB_size), "=m" (temp)
		:
		: "eax"
	);
	DB_offs = temp<<4;
	term_puts( SCR_DEBUG, "DiskBuffer size = ");
	 term_hexprintl( SCR_DEBUG, DB_size );
	 term_puts( SCR_DEBUG, "\r\n");
	term_puts( SCR_DEBUG, "DiskBuffer offset = ");
	 term_hexprintl( SCR_DEBUG, DB_offs );
	 term_puts( SCR_DEBUG, "\r\n");
}

void LoadFile()
{
	 term_puts(  SCR_DEBUG, "Searching DiskBuffer...\r\n");
	GetBufferInfo();

	 term_puts( SCR_DEBUG, "Loading Data...\r\n");
	LoadSectors( file_data_start, file_sector_count );
}

void SaveFile()
{
	 term_puts(  SCR_DEBUG, "Searching DiskBuffer...\r\n");
	GetBufferInfo();

	 term_puts( SCR_DEBUG, "Saving Data...\r\n");
	SaveSectors( file_data_start, file_sector_count );
}

int GetFileInfo(char* fname)
{
	char found;

	asm("
		mov %5,%%edi;
		mov $10,%%eax;
		int $0x20;

		mov %%al,%0;	// I don't know how to use labels with DJGPPs inline assembler, so simply copy
				// everything without checking for success
		mov %%dl,%1;
		mov %%ebx,%2;
		mov %%ecx,%3;
		mov %%ah,%4
		"
		: "=m" (found), "=m" (file_disk), "=m" (file_data_start), "=m" (file_sector_count), "=m" (file_attributes)
		: "m" (fname)
		: "eax", "ebx", "ecx", "edx", "edi"	//destroyed registers ?
	);
	
	if(found!=0)
	{
		term_puts( SCR_DEBUG, "File not found!\r\n");
		//puts("File not found error!\r\n");
		return 0;
	}
	term_puts( SCR_DEBUG, "found!\r\n");

	file_rawlength = file_sector_count*512;

	term_puts( SCR_DEBUG, "File info:\r\n");	// Print File Information
	term_puts( SCR_DEBUG, "Disk: ");
	 term_hexprintb( SCR_DEBUG, file_disk);
	 term_puts( SCR_DEBUG, "\r\n");
	term_puts( SCR_DEBUG, "First sector: ");
	 term_hexprintl( SCR_DEBUG, file_data_start);
	 term_puts( SCR_DEBUG, "\r\n");
	term_puts( SCR_DEBUG, "Sector count: ");
	 term_hexprintl( SCR_DEBUG, file_sector_count);
	 term_puts( SCR_DEBUG, "\r\n");
	term_puts( SCR_DEBUG, "Size: ");
	 term_hexprintl( SCR_DEBUG, file_rawlength);
	 term_puts( SCR_DEBUG, "\r\n");

	return 1;
}