/* testapp.c */

/*
 * 10/12/1999 Joost Faassen, Carlo Prelz
 * Copyright (C) V2_Lab Rotterdam
 *
 * A test application for V2_OS with examples of how to use library functions
 *
 * $Log: testapp.c,v $
 * Revision 1.1  1999/12/10 15:32:08  karl
 * Initial revision
 *
 */

#include "v2os.h"

static unsigned char bfr[256];

void main(void)
{
	unsigned char c,c2;
	unsigned short s;
	unsigned long l;

/*
 * Null function
 */
	
  nullf();

/*
 * Write a character to screen. First attributes, then a nifty countdown!
 */
	
	pokeb(0x18,0xb8000+11,0x1f);
  for(c='9';c>='0';c--)
	{
    pokeb(0x18,0xb8000+10,c);
		delay(2);
	}

/*
 * Canonical...
 */
	
	puts("Hello, World!\r\n");

/*
 * Print a formatted number
 */
	
	num_to_string(12345,bfr,10,1);
	puts(bfr);

/*
 * Train the hexprint functions: a character, a short and a long
 */
	
	c=0xef;
	s=0x1234;
	l=0xabcd9876;

	hexprintb(c);
	puts("\r\n");
	hexprints(s);
	puts("\r\n");
	hexprintl(l);
	puts("\r\n");

/*
 * Train the routines that print to various screens.
 * Symbolic values as defined in v2os.h should be used...
 */
	
	for(c2=0;c2<5;c2++)
	{
		puts("v=");
		hexprintb(c2);
		puts("\r\n");
		term_puts(c2,"Debug message ");
		term_hexprintb(c2,c);
		term_puts(c2," ");
		term_hexprints(c2,s);
		term_puts(c2," ");
		term_hexprintl(c2,l);
		term_puts(c2,"\r\n");
  }

/*
 * Test the keypress function.
 */
	
  do
	{
		puts("Press a key (q to exit)...");
		c=getkey();
		puts("You pressed ");
		hexprintb(c);
		puts(" (");
		bfr[0]=c;
		bfr[1]='\0';
		puts(bfr);
		puts(")\r\n");
	}
	while(c!='q');

/*
 * The string insertion function...
 */
	
	gets(bfr);
	puts("You inserted <");
	puts(bfr);
	puts(">.\r\n");

/*
 * and the shell command funct (with the string that was previously inserted)
 */
	
	l=v2_strlen(bfr);
	bfr[l]='\r';
	bfr[l+1]='\n';
	bfr[l+2]='\0';
	
	shell_command(bfr);

	puts("*** The END ***\r\n");
}
