/* lib.cpp

 *

 * 13/12/1999 Don Simpson

 *

 * Library of standard functions for developing modules and applications

 * for V2_OS in Microsoft Visual C++

 *

 */



#include "v2os.h"



/*

 * Test routine - calls System32 NULL function

 */



inline void nullf()

{

	_asm

	{

		mov al, 0

		int 0x20

	}

}



//inline void pokeb(unsigned short Seg, unsigned long Off, unsigned char Data)

//{

//	_asm

//	{

//		mov ax, Seg

//		mov edi, Off

//		mov al, Data

//		mov ah, 00

//		mov fs:[edi], ax

//	}

//}



/*

 * Write a string to the main terminal. User should add \r\n

 */



inline void puts(char *msg)

{

	for(int i=0;i<255 && msg[i]!='\0';i++)

		in_bfr[i]=msg[i];

	in_bfr[i]='\0';

  

  	_asm

	{

   		mov al, 4               // System32 Service 4 (Print Text)

		mov edi, offset in_bfr  // Pointer to text

		int 0x020               // Do System32 Service

	}

}



/*

 * Write a string to a given screen. User should add \r\n

 * <screen> should be set to one of the predefined variables

 * in v2os.h (SCR_TERMINAL, etc)

 */



inline void term_puts(unsigned char screen, char *msg)

{

	for(int i=0;i<255 && msg[i]!='\0';i++)

		in_bfr[i]=msg[i];

	in_bfr[i]='\0';

  

	_asm

	{

		mov ax, 38

		mov dl, screen

		mov edi, offset in_bfr  // Pointer to text

		int 0x20

	}

}



/*

 * Pauses for given amount of 25ths of second

 */



void delay(unsigned long sec_25ths)

{

	_asm

	{

		mov ax, 26

		mov edi, sec_25ths

		int 0x20

	}

}



/*

 * Print a byte, a short or a long to main terminal in hex

 */



void hexprintb(unsigned char val)

{

	_asm

	{

		mov ax, 0x105

		mov bl, val

		int 0x20

	}

}



void hexprints(unsigned short val)

{

	_asm

	{

		mov ax, 0x205

		mov bx, val

		int 0x20

	}

}



void hexprintl(unsigned long val)

{

	_asm

	{

		mov ax, 0x405

		mov ebx, val

		int 0x20

	}

}



/*

 * Print a byte, a short or a long to a screen in hex. <screen>

 * is set as in term_puts above

 */



void term_hexprintb(unsigned char screen, unsigned char val)

{

	_asm

	{

		mov ax, 0x127

		mov dl, screen

		mov bl, val

		int 0x20

	}

}



void term_hexprints(unsigned char screen, unsigned short val)

{

	_asm

	{

		mov ax, 0x227

		mov dl, screen

		mov bx, val

		int 0x20

	}

}



void term_hexprintl(unsigned char screen, unsigned long val)

{

	_asm

	{

		mov ax, 0x427

		mov dl, screen

		mov ebx, val

		int 0x20

	}

}



/*

 * Waits for a keypress. Returns the character

 */



unsigned char getkey()

{

	unsigned char c;

	

	_asm

	{

		mov ax, 23

		int 0x20

		mov ax, 29

		int 0x20

		mov c, al

	}



	return c;

}



/*

 * Reads a string from terminal. Must pass buffer with enough space

 */



void gets(char *bfr)

{

	_asm

	{

		mov ax, 40

		mov edi, offset out_bfr

		int 0x20

	}



	for(int i=0;i<256 && out_bfr[i];i++)

		bfr[i]=out_bfr[i];

	bfr[i]='\0';

}



/*

 * Executes a V2_OS shell command

 */



void shell_command(char *cmd)

{

	for(int i=0;i<255 && cmd[i]!='\0';i++)

		in_bfr[i]=cmd[i];

	in_bfr[i]='\0';



	_asm

	{

		mov ax, 25

		mov edi, offset in_bfr

		int 0x20

	}

}



/*

 * C routines...

 *

 * Convert from number to string.

 * val: input value

 * bfr: resulting string. Buffer is passed from caller.

 * len: length of the resulting string. If number is smaller,

 * string is completed with 0's,

 */



void num_to_string(int val, char *bfr,int len,unsigned char flg_cr)

{

  int i;

  

  for(i=len-1;i>=0;i--)

  {

    bfr[i]='0'+(val%10);

    val/=10;

  }



  if(flg_cr)

  {

    bfr[len]='\r';

    bfr[len+1]='\n';

    bfr[len+2]='\0';

  }

  else

    bfr[len]='\0';

}



/*

 * Returns the length of a string

 */



int v2_strlen(char *bfr)

{

	int to_ret;



	for(to_ret=0;bfr[to_ret];to_ret++)

		;



	return to_ret;

}