/*
  memman.c - Memory Management of SimpleEdit
*/

void MoveMemory( int pos, int count, int direction)
{
	int amount=text_size-pos; //1 if pos==length-1 (maximum), length-1 if pos==0
	if( direction==0 )
	{
	asm("
		std
		mov %0, %%ecx
		mov %1, %%esi
		mov %1, %%edi
		add %2, %%edi
		add %2, %%esi
		sub %3, %%esi

		push %%es
		push %%ds
		 push %%gs
		 pop %%ds
		 push %%gs
		 pop %%es
		  rep movsb
		pop %%ds
		pop %%es
		cld
		"
		:
		: "m" (amount), "m" (TB_ptr), "m" (text_size), "m" (count)
		: "edi", "esi", "ecx"
	);
	return;
	}
else
	{
		//BACKWARDS!!
	asm("
		cld
		mov %0, %%ecx
		mov %1, %%esi
		mov %1, %%edi
		add %2, %%edi
		add %2, %%esi
		add %3, %%esi

		push %%es
		push %%ds
		 push %%gs
		 pop %%ds
		 push %%gs
		 pop %%es
		  rep movsb
		pop %%ds
		pop %%es
		"
		:
		: "m" (amount), "m" (TB_ptr), "m" (pos), "m" (count)
		: "eax", "esi", "edi", "ecx"
	);
	}
}

void MemCopy(int source, int dest, int count)
{
	asm("
		mov %0, %%esi
		mov %1, %%edi
		mov %2, %%ecx

		push %%es
		push %%ds
		 push %%gs
		 pop %%ds
		 push %%gs
		 pop %%es
		  rep movsb
		pop %%ds
		pop %%es
		"
		:
		: "m" (source), "m" (dest), "m" (count)
		: "esi", "edi", "ecx"
	);
}

int AllocateMemory( int* size )
{
	int offs;
	int sz=*size;

	asm("
		mov $14, %%al;
		mov %2, %%ebx;
		mov $0, %%dl
		mov $1, %%dh
		int $0x20

		//mov %%cx, %0
		mov %%edi, %0
		mov %%ebx, %1

		// We don't need the Selector, so free it right away...
		mov $15, %%al
		mov %%cx, %%bx; //selector to destroy
		int $0x20
		"
		: "=m" (offs), "=m" (sz)
		: "m" (*size)
		: "eax", "ebx", "ecx", "edx", "edi"
	);

	*size=sz;
	return offs;
}

void GetMemory()
{
	BB_size=BB_MaxSize;
	BB_ptr=AllocateMemory( &BB_size );
	BB_UsedSize=0;
}

void AllocAdditionalBuffer(int size)
{
	int ptr_2;
	int size_2;

	size_2 = size;
	ptr_2 = AllocateMemory( &size_2 );

	term_puts( SCR_DEBUG, "Additional buffer allocated!\r\n" );

	if( ptr_2 != (int)TB_ptr+TB_size )
		term_puts( SCR_DEBUG, "!! WARNING: Allocated Buffer is NOT in line to old one!!" );

	TB_size += size_2;
}
