/* v2os.h */

/*
 * 10/12/1999 Joost Faassen, Carlo Prelz
 * Copyright (C) V2_Lab Rotterdam
 *
 * Standard include file for developing modules and applications
 * for V2_OS in C/Linux
 *
 * $Log: v2os.h,v $
 * Revision 1.2  1999/12/23 10:14:02  karl
 * Added module support
 *
 * Revision 1.1  1999/12/10 17:22:39  karl
 * Initial revision
 *
 */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define SCR_TERMINAL 0
#define SCR_DEBUG 1
#define SCR_BOOTLOG 2
#define SCR_MODLOAD 3
#define SCR_CRASH 4

#define MEM_HIGH 0
#define MEM_LOW 1

#define NULL (void *)0

#define BASIC_SERVICES 16
#define LIB_SERVICES 2
#define START_USER_SERVICES BASIC_SERVICES+LIB_SERVICES

#define SVC_GET_PROTO_INPUT_ADDR BASIC_SERVICES
#define SVC_GET_INPUT_ADDR BASIC_SERVICES+1

#define outb( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned char  __value = _value; \
     \
     asm volatile ( "outb %0,%1" : "=a" (__value), "=d" (__port) \
				 : "0"   (__value), "1"  (__port) \
		  ); \
   }

#define outw( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned short __value = _value; \
     \
     asm volatile ( "outw %0,%1" : "=a" (__value), "=d" (__port) \
				 : "0"   (__value), "1"  (__port) \
		  ); \
   }

#define outl( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned long __value = _value; \
     \
     asm volatile ( "outl %0,%1" : "=a" (__value), "=d" (__port) \
				 : "0"   (__value), "1"  (__port) \
		  ); \
   }

#define inb( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned char  __value = 0; \
     \
     asm volatile ( "inb %1,%0" : "=a" (__value), "=d" (__port) \
				: "0"   (__value), "1"  (__port) \
		  ); \
     _value = __value; \
   }

#define inw( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned short __value = 0; \
     \
     asm volatile ( "inw %1,%0" : "=a" (__value), "=d" (__port) \
				: "0"   (__value), "1"  (__port) \
		  ); \
     _value = __value; \
   }

#define inl( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned long __value = 0; \
     \
     asm volatile ( "inl %1,%0" : "=a" (__value), "=d" (__port) \
				: "0"   (__value), "1"  (__port) \
		  ); \
     _value = __value; \
   }

#define RETF asm("movl %ebp,%esp;popl %ebp;lret")
#define RETF_EDI(edi) \
asm( \
"movl %0,%%edi;movl %%ebp,%%esp;popl %%ebp;lret" \
: \
: "m" (edi) \
)

extern unsigned char lib_in_bfr[],lib_out_bfr[];

//extern void printptrs(void);

extern inline void nullf(void);
extern inline void retf(void);
extern inline void pokeb(unsigned short Seg, unsigned long Off, unsigned char Data);
extern inline void pokel(unsigned short Seg, unsigned long Off, unsigned long Data);
extern inline unsigned long peekl(unsigned short Seg, unsigned long Off);
extern inline void puts(unsigned char *msg);
extern inline void term_puts(unsigned char term,unsigned char *msg);
extern void delay(unsigned long sec_18ths);
extern void hexprintb(unsigned char value);
extern void hexprints(unsigned short value);
extern void hexprintl(unsigned long value);
extern void term_hexprintb(unsigned char term,unsigned char value);
extern void term_hexprints(unsigned char term,unsigned short value);
extern void term_hexprintl(unsigned char term,unsigned long value);
unsigned char getkey(void);
void gets(unsigned char *msg);
void shell_command(unsigned char *cmd);
void *service_input_data(unsigned char *modname,int req_service);
void *modservice(unsigned char *modname,int service);
void open_memory(void);
void *malloc(int size,unsigned char mem_pos,unsigned short *ret_sel,unsigned long *abs_address);
void *abs_to_relative(unsigned long abs_address);
unsigned long whats_my_address(void);
void v2_memcpy(void *from,void *to,int len);
/**/
extern void num_to_string(int val,unsigned char *bfr,int len,unsigned char flg_cr);
int v2_strlen(unsigned char *bfr);
void print_address(unsigned char *name,void *ptr);
void print_abs_address(unsigned char *name,void *ptr);
extern void num_to_string(int val,unsigned char *bfr,int len,unsigned char flg_cr);
