[bits 32]
org	0x100
%include "glib.asm"	; include graphics macros

	jmp	Start		; skip over variables

kbdPtr	equ	600h + 74

sWidth	equ	320
sHeight	equ	200

baSize	equ	2

bd		equ	3
pWidth	equ	3
pHeight	equ	20
pSpd		equ	2

bdColor	equ	41
lColor	equ	9
rColor	equ	9
baColor	equ	10
black		equ	0

kQ		equ	10h
kA		equ	1Eh
kZ		equ	2Ch
kQuot		equ	28h
kSlash		equ	35h

lX	equ	bd
rX	equ	sWidth-bd-pWidth

initX	equ	sWidth/2-1-baSize/2
initY	equ	sHeight/2-1-baSize/2

baSpd		equ	1
velX		dd	-1
velY		dd	-1

lY:	dd	sHeight/2-1-pWidth/2
rY:	dd	sHeight/2-1-pWidth/2

baX:	dd	initX
baY:	dd	initY

kbd:	dd	0

Start:
	mov		edi, [gs:kbdPtr]
	mov		[kbd], edi
	setMode	0x13
newGame:
	mov dword	[baX], initX
	mov dword	[baY], initY

	drawBox	0,0,sWidth,sHeight,black	; clear screen

MainLoop:
	waitR

; Draw border
	drawBox	0, 0, bd, sHeight, bdColor		; left
	drawBox	0, 0, sWidth, bd, bdColor		; top
	drawBox	sWidth-bd, 0, bd, sHeight, bdColor	; right
	drawBox	0, sHeight-bd, sWidth, bd, bdColor	; bottom

; Erase paddles
	drawBox	lX, [lY], pWidth, pHeight, black
	drawBox	rX, [rY], pWidth, pHeight, black

; Erase ball
	drawBox	[baX], [baY], baSize, baSize, black


; Check input
	mov dword	edi, [kbd]
	cmp byte	[gs:edi+kA], 0h
	jnz near	keyA
aNt:	cmp byte	[gs:edi+kZ], 0h
	jnz near	keyZ
zNt:	cmp byte	[gs:edi+kQuot], 0h
	jnz near	keyQuot
qNt:	cmp byte	[gs:edi+kSlash], 0h
	jnz near	keySlash
sNt:	cmp byte	[gs:edi+kQ], 0h		
	jnz near	exit

; Move ball
	mov		eax, [velX]
	add		[baX], eax
	mov		eax, [velY]
	add		[baY], eax

	cmp dword	[baX], bd+pWidth
	jb near	hitLeft
lNt:	cmp dword	[baX], sWidth-bd-baSize-pWidth
	ja near	hitRight
rNt:	cmp dword	[baX], bd
	jb near	missLeft
	cmp dword	[baX], sWidth-bd-baSize
	ja near	missRight
	cmp dword	[baY], bd
	jb near	hitTop
tNt:	cmp dword	[baY], sHeight-bd-baSize
	ja near	hitBottom
bNt:

; Draw paddles
	drawBox	lX, [lY], pWidth, pHeight, lColor
	drawBox	rX, [rY], pWidth, pHeight, rColor

; Draw ball
	drawBox	[baX], [baY], baSize, baSize, baColor


; Dump Buffer
	mov	ax, 1Dh
	int	20h
	jmp	MainLoop

missLeft:
	mov dword	[baX], bd
	mov dword	[velX], baSpd
	jmp		newGame

missRight:
	mov dword	[baX], sWidth-bd-baSize
	mov dword	[velX], -baSpd
	jmp		newGame

hitLeft:
	mov		edx, [baY]
	cmp		edx, [lY]
	jb near	lNt
	sub		edx, pHeight+baSize/2
	cmp		edx, [lY]
	ja near	lNt
	mov dword	[baX], bd+pWidth
	mov dword	[velX], baSpd
	jmp		lNt

hitRight:
	mov		edx, [baY]
	cmp		edx, [rY]
	jb near	rNt
	sub		edx, pHeight+baSize/2
	cmp		edx, [rY]
	ja near	rNt
	mov dword	[baX], sWidth-bd-baSize-pWidth
	mov dword	[velX], -baSpd
	jmp		rNt

hitTop:
	mov dword	[baY], bd
	mov dword	[velY], baSpd
	jmp		tNt

hitBottom:
	mov dword	[baY], sHeight-bd-baSize
	mov dword	[velY], -baSpd
	jmp		bNt

keyA:	mov		eax, [lY]
	cmp		eax, bd
	jb		aFix
	je		aFix
	sub dword	[lY], pSpd
	jmp		aNt
aFix:
	mov dword	[lY], bd
	jmp		aNt

keyZ:	mov		eax, [lY]
	cmp		eax, sHeight-bd-pHeight
	ja 		zFix
	je		zFix
	add dword	[lY], pSpd
	jmp		zNt
zFix:
	mov dword	[lY], sHeight-bd-pHeight
	jmp		zNt

keyQuot:
	mov		eax, [rY]
	cmp		eax, bd
	jb		qFix
	je		qFix
	sub dword	[rY], pSpd
	jmp		qNt
qFix:
	mov dword	[rY], bd
	jmp		qNt

keySlash:
	mov		eax, [rY]
	cmp		eax, sHeight-bd-pHeight
	ja		sFix
	je		sFix
	add dword	[rY], pSpd
	jmp		sNt
sFix:
	mov dword	[rY], sHeight-bd-pHeight
	jmp		sNt

exit:	
	normalMode
dump:		
	mov	ax, 1Dh
	int	20h
	cmp	ax, 0
	jnz	dump
	
; Print newLine
	mov	ax, 4h
	mov	edi, newLine
	int	20h

	retf


newLine:
	db	0dh, 0ah, 0