; This is a nasm example showing how to create a "module" for the v2_os.
; Author:		Andrew Johnson
; E-mail:		thelaser@hotmail.com
; Date:		12/12/1999
; Disclaimer:	I don't think this is going to do anything terrible,
;			but it might.  Use at your own risk.

[bits 32]
org 100h

; First, the header.
	jmp	run			; Catch people 'running' the module
	times 3	db	0	; Fill up to 08h, but not 08h

	db	'V2MD'		; Abbracadabra, a magic word
	db	'TestMod0'		; Module ID (8 characters)
	db	0,0Ah			; Version number of module (0.1)
	db	0,1			; Version number of V2_OS required
	
	dd	MOD_LOAD		; pointer to MOD_LOAD
	dd	MOD_UNLOAD		; pointer to MOD_UNLOAD
	dd	MOD_TABLE		; pointer to MOD_TABLE

	dd	MOD_NAME
	dd	MOD_DESCRIPTION
	dd	MOD_COPYRIGHT

; Then some strings
MOD_NAME:
	db	'Test Module 0', 0
MOD_DESCRIPTION:
	db	'Test and Example Module', 0
MOD_COPYRIGHT:
	db	'Public Domain', 0
runMsg:
	db	'This is a "module" and cannot be run', 0Dh, 0Ah
	db	"Please, use the 'loadmod' command instead!", 0Dh, 0Ah, 0
loadMsg:
	db	'Test module 0 loading...', 0Dh, 0Ah, 0
unloadMsg:
	db	'Test module 0 unloading...', 0Dh, 0Ah, 0
serv10Msg:
	db	'This is TestMod0, Service 10', 0Dh, 0Ah, 0
serv11Msg:
	db	'This is TestMod0, Service 11', 0Dh, 0Ah, 0

; And then the routines
run:
	mov	al, 04h
	mov	edi, runMsg
	int	20h			; Print String
	retf

reserved:
	retf

MOD_LOAD:
	mov	al, 04h
	mov	edi, loadMsg
	int	20h			; Print string
	retf

MOD_UNLOAD:
	mov	al, 04h
	mov	edi, unloadMsg
	int	20h			; Print string
	retf

serv10:
	push	ax
	push	edi
	mov	al, 04h
	mov	edi, serv10Msg
	int	20h			; Print string
	pop	edi
	pop	ax
	retf

serv11:
	push	ax
	push	edi
	mov	al, 04h
	mov	edi, serv11Msg
	int	20h			; Print string
	pop	edi
	pop	ax
	retf

; And finally the service table
	align	4, db 	0h	; Place on a 4-byte boundry, so things go faster
MOD_TABLE:
	dd	reserved		; Service 00h
	dd	reserved		; Service 01h
	dd	reserved
	dd	reserved
	dd	reserved
	dd	reserved
	dd	reserved
	dd	reserved		; Services 00-0F are reserved
	dd	reserved
	dd	reserved
	dd	reserved
	dd	reserved
	dd	reserved
	dd	reserved
	dd	reserved
	dd	reserved		; Service 0Fh
	dd	serv10
	dd	serv11
	dd	0			; Terminate the table
	







