/* v2fs.c */

/*
 * 05/08/1999 c.e. prelz
 * Copyright 1999 V2 Labs
 *
 * Inits a partition for v2 video use
 *
 * $Log: v2_init.c,v $
 * Revision 2.2  1999/12/23 11:15:43  karl
 * GPLized
 *
 * Revision 2.1  1999/09/03 08:49:01  karl
 * Before trying to split the two fields of each frame
 *
 * Revision 1.2  1999/08/25 14:04:24  karl
 * Before making the beginning sector variable
 *
 * Revision 1.1  1999/08/16 13:40:44  karl
 * Initial revision
 *
 */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <v2fs.h>

void usage(void);

void main(int argc,char *argv[])
{
  unsigned char bfr[256];
  int i,maxob;
  unsigned char sect16,sect32;
  
  if(argc<3)
    usage();
  if(sscanf(argv[2],"%d",&maxob)<1)
  {
    fprintf(stderr,"Maxob <%s> ???\n",argv[2]);
    usage();
  }
  if(argc>3)
  {
    if(sscanf(argv[3],"%d",&i)<1)
      usage();
    sect16=i;
    if(sscanf(argv[4],"%d",&i)<1)
      usage();
    sect32=i;
  }
  else
    sect16=sect32=0;
  
  while(1)
  {
    printf("\n\n\n%s\nAbout to initialize partition *%s* for %d max objects. Sect16=%d. Sect32=%d\n"
           "Remember that the partition must be blanked before running this program.\n"
           "Please type \"yes\" to confirm:",argv[0],argv[1],maxob,sect16,sect32);
    fgets(bfr,256,stdin);
    if(!strlen(bfr))
      break;
    if(strcasecmp(bfr,"yes"))
    {
      if(v2fs_init(argv[1],maxob,sect16,sect32))
        printf("Error!!\n");
      else
        printf("Done.\n");
      break;
    }
    printf("<%s> ???\n",bfr);
  }
}

void usage(void)
{
  fprintf(stderr,"Usage: v2_init <partition> <max-objects> [<16-sects> <32-sects>]\n");
  exit(1);
}
