/* v2fs_delete.c */

/*
 * 27/08/1999 c.e. prelz
 * Copyright (C) 1999 V2 Lab Rotterdam
 *
 * Deletes a movie from a v2fs partition
 *
 * $Log: v2fs_delete.c,v $
 * Revision 2.2  1999/12/23 11:15:43  karl
 * GPLized
 *
 * Revision 2.1  1999/09/03 08:49:01  karl
 * Before trying to split the two fields of each frame
 *
 * Revision 1.1  1999/08/27 09:37:41  karl
 * Initial revision
 *
 */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <v2gen.h>
#include <v2fs.h>

void usage(void);

void main(int argc,char *argv[])
{
  v2fs *fs;
  unsigned char *pname=NULL,*fname=NULL,bfr[256],*ptr;
  int i;
  
  while((i=getopt(argc,argv,"p:m:"))!=EOF)
  {
    switch(i)
    {
    case 'p':
      pname=safrealloc(pname,strlen(optarg)+1);
      strcpy(pname,optarg);
      break;      
    case 'm':
      fname=safrealloc(fname,strlen(optarg)+1);
      strcpy(fname,optarg);
      break;
    default:
      usage();
    }
  }
  
  if(pname==NULL || fname==NULL)
    usage();    
    
  if((fs=v2fs_open(pname,0))==NULL)
  {
    fprintf(stderr,"%s: error opening v2fs partition <%s>\n",argv[0],pname);
    exit(1);
  }

/*
 * Find where the movie is
 */
  
  if(v2fs_whichmovie(fs,fname,NULL)<0)
  {
    fprintf(stderr,"%s: could not find movie <%s>\n",argv[0],fname);
    exit(1);
  }

/*
 * Is s/he really sure?
 */

  while(1)
  {
    printf("About to delete movie <%s> from partition <%s>\nAre you REALLY sure? (yes/no):",
           fname,pname);
    fgets(bfr,256,stdin);

    if((ptr=strrchr(bfr,'\n'))!=NULL)
      *ptr='\0';
    
    if(!strlen(bfr) || !strcasecmp(bfr,"no"))
      break;

    if(!strcasecmp(bfr,"yes"))
    {
      v2fs_delete(fs,fname);
      
      printf("Done!\n");

      break;
    }

    printf("<%s> ???\n",bfr);
  }
}

void usage(void)
{
  fprintf(stderr,"Usage: v2fs_delete -p <v2fs partition> -m <movie name>\n");
  exit(1);
}

