/* v2os.h */

/*
 * 10/12/1999 Joost Faassen, Carlo Prelz
 * Copyright (C) V2_Lab Rotterdam
 *
 * Standard include file for developing modules and applications
 * for V2_OS in C/Linux
 *
 * $Log: v2os.h,v $
 * Revision 1.1  1999/12/10 17:22:39  karl
 * Initial revision
 *
 */

#define SCR_TERMINAL 0
#define SCR_DEBUG 1
#define SCR_BOOTLOG 2
#define SCR_MODLOAD 3
#define SCR_CRASH 4

#define outb( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned char  __value = _value; \
     \
     asm volatile ( "outb %0,%1" : "=a" (__value), "=d" (__port) \
				 : "0"   (__value), "1"  (__port) \
		  ); \
   }

#define outw( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned short __value = _value; \
     \
     asm volatile ( "outw %0,%1" : "=a" (__value), "=d" (__port) \
				 : "0"   (__value), "1"  (__port) \
		  ); \
   }

#define outl( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned long __value = _value; \
     \
     asm volatile ( "outl %0,%1" : "=a" (__value), "=d" (__port) \
				 : "0"   (__value), "1"  (__port) \
		  ); \
   }

#define inb( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned char  __value = 0; \
     \
     asm volatile ( "inb %1,%0" : "=a" (__value), "=d" (__port) \
				: "0"   (__value), "1"  (__port) \
		  ); \
     _value = __value; \
   }

#define inw( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned short __value = 0; \
     \
     asm volatile ( "inw %1,%0" : "=a" (__value), "=d" (__port) \
				: "0"   (__value), "1"  (__port) \
		  ); \
     _value = __value; \
   }

#define inl( _port, _value ) \
   { register unsigned short __port  = _port; \
     register unsigned long __value = 0; \
     \
     asm volatile ( "inl %1,%0" : "=a" (__value), "=d" (__port) \
				: "0"   (__value), "1"  (__port) \
		  ); \
     _value = __value; \
   }

extern inline char peekb( unsigned short Seg, unsigned long Off);
int peekl( unsigned short Seg, unsigned long Off);
void pokel( unsigned short Seg, unsigned long Off, long data );
extern inline void nullf(void);
extern inline void pokeb(unsigned short Seg, unsigned long Off, unsigned char Data);
extern inline void puts(unsigned char *msg);
extern inline void term_puts(unsigned char term,unsigned char *msg);
extern void delay(unsigned long sec_18ths);
extern void hexprintb(unsigned char value);
extern void hexprints(unsigned short value);
extern void hexprintl(unsigned long value);
extern void term_hexprintb(unsigned char term,unsigned char value);
extern void term_hexprints(unsigned char term,unsigned short value);
extern void term_hexprintl(unsigned char term,unsigned long value);
unsigned char getkey(void);
unsigned char getkey_nowait();
void gets(unsigned char *msg);
void shell_command(unsigned char *cmd);
/**/
extern void num_to_string(int val,unsigned char *bfr,int len,unsigned char flg_cr);
int v2_strlen(unsigned char *bfr);

int CheckModuleInstallation( const unsigned char* modul_name);