typedef struct
{
	int TB_size;
	int TB_ptr;

	int LB_ptr;
	int LB_size;

	int line_count;

	int text_size;
	int text_style;

	int Mark_Start;
	int Mark_End;

	int t_x,t_y;
	int c_x,c_y;

	char filename[40];
} tWindow_Info;

tWindow_Info Win_Buffer;

int win_flags[MaxWindows]; // 0=uninitialized&unused, 1=initialized&unused, 2=used

void win_TransportIn(int winnr)
{
	asm("
		mov %0, %%esi
		mov %1, %%edi
		mov %2, %%ecx

		push %%es
		push %%ds

		push %%ds
		pop %%es
		push %%gs
		pop %%ds

		 rep movsb

		pop %%ds
		pop %%es
		"
		:
		: "m" (WINS_ptr+winnr*sizeof(tWindow_Info)), "m" (&Win_Buffer), "m" (sizeof(tWindow_Info))
		: "esi", "edi", "ecx"
	);

	TB_size=Win_Buffer.TB_size;
	TB_ptr=Win_Buffer.TB_ptr;

	LB_ptr=Win_Buffer.LB_ptr;
	LB_size=Win_Buffer.LB_size;

	line_count=Win_Buffer.line_count;

	text_size=Win_Buffer.text_size;
	text_style=Win_Buffer.text_style;

	Mark_Start=Win_Buffer.Mark_Start;
	Mark_End=Win_Buffer.Mark_End;

	t_x=Win_Buffer.t_x;
	t_y=Win_Buffer.t_y;
	c_x=Win_Buffer.c_x;
	c_y=Win_Buffer.c_y;

	if( win_flags[winnr]!=0 ) // Don't attept to copy an unitialized string
		strcpy( &Win_Buffer.filename[0], &file_name[0] );

	current_window=winnr;
}

void win_TransportBack()
{
	if( current_window==-1 )
		return;

	Win_Buffer.TB_size=TB_size;
	Win_Buffer.TB_ptr=TB_ptr;

	Win_Buffer.LB_ptr=LB_ptr;
	Win_Buffer.LB_size=LB_size;

	Win_Buffer.line_count=line_count;

	Win_Buffer.text_size=text_size;
	Win_Buffer.text_style=text_style;

	Win_Buffer.Mark_Start=Mark_Start;
	Win_Buffer.Mark_End=Mark_End;

	Win_Buffer.t_x=t_x;
	Win_Buffer.t_y=t_y;
	Win_Buffer.c_x=c_x;
	Win_Buffer.c_y=c_y;

	strcpy( &file_name[0], &Win_Buffer.filename[0] );

	asm("
		mov %1, %%esi
		mov %0, %%edi
		mov %2, %%ecx
		push %%es
		push %%gs
		pop %%es
		 rep movsb
		pop %%es
		"
		:
		: "m" (WINS_ptr+current_window*sizeof(tWindow_Info)), "m" (&Win_Buffer), "i" (sizeof(tWindow_Info))
		: "esi", "edi", "ecx"
	);
}

void win_switch(int WinNR)
{
	if( win_flags[WinNR]!=2 )
		return;
	win_TransportBack();
	win_TransportIn( WinNR );
}

void win_next()
{
	int i=current_window;

	do
	{
		i=(i+1)%MaxWindows;
		if( win_flags[i]==2 ) break;
	}
	while( i!=current_window );

	win_switch( i );
}

void win_close()
{
	int i;

	if( win_flags[current_window]!=2 )
		return;

	win_flags[current_window]=1;

	for( i=0; i<MaxWindows; i++ )
		if( win_flags[i]==2 ) break;

	if( i==MaxWindows )
	{
		Error(" Cannot close the last window");
		win_flags[current_window]=2;
		return;
	}
	win_TransportIn( i );
}

int win_new()
{
	int i;

	for( i=0; i<MaxWindows; i++ )
		if( win_flags[i]!=2 ) break;

	if( i==MaxWindows ) //No more free windows
	{
		Error(" Sorry, too many windows (maximum of 10 allowed) ");
		return 0;
	}

//	term_puts( SCR_DEBUG, "Transportation...\r\n");

	win_TransportBack(); // Save current window
	win_TransportIn( i );

	if( win_flags[i]==0 ) // need to initialize memory stuff
	{
		LB_size=MaxLines*8;
		LB_ptr=AllocateMemory( &LB_size );

		TB_size = 1024*256 + SecurityDistance;
		TB_ptr = AllocateMemory( &TB_size );
	}

	line_count=1;
	text_size=1;
	text_style=0;

	Mark_Start = 0;
	Mark_End = -1;

	c_x=0;
	c_y=0;
	t_x=0;
	t_y=0;

//	term_puts( SCR_DEBUG, "starting strcpy()...\r\n");
	strcpy( "noname ", &file_name[0] );

//	term_puts( SCR_DEBUG, "filename...\r\n");
	file_name[6]='0'+i;

	SetLineLength(0, 0);
	SetLineStart(0, 0);

	SetChar(0, 0);
	SetChar(1, 0);

	current_window=i;

	win_flags[i]=2;

	return 1;
}

int size;
void win_init()
{
	int i;

	size=MaxWindows*sizeof(tWindow_Info);

//	term_puts( SCR_DEBUG, "AllocateMemory()...\r\n");
	WINS_ptr=AllocateMemory( &size );

	for( i=0; i<MaxWindows; i++ )
		win_flags[i]=0;

	current_window=-1;

//	term_puts( SCR_DEBUG, "win_new()...\r\n");
	win_new();
}
